package com.biganto.visual.roompark.presentation.screen.splash

import DaggerSplashScreenComponent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.ICollapsingToolBar
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.conductor.BigantoBaseController
import com.google.android.material.snackbar.Snackbar
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

class SplashScreenController  :
    BigantoBaseController<SplashScreenViewState
        , SplashScreen
        , SplashScreenPresenter>()
    , SplashScreen {

    override fun injectDependencies() {
        getComponent()
    }

    @Inject
    lateinit var tb: ICollapsingToolBar


//    @Inject
//    lateinit var snacky:ISnackBarProvider

    lateinit var rpActivity: RoomParkMainActivity

    fun getComponent() = DaggerSplashScreenComponent
        .factory()
        .create(RoomParkApplication.component,activity as RoomParkMainActivity)
        .inject(this)

//    @Inject
//    lateinit var ac: RoomParkMainActivity

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup): View {
        val v = super.onCreateView(inflater, container)

        snackbar.showSnackBar("AZZZA", Snackbar.LENGTH_LONG)
        return v
    }


    override fun render(viewState: SplashScreenViewState) {
        when(viewState){
            is SplashScreenViewState.Idle -> render(viewState)
            is SplashScreenViewState.ToScreen -> render(viewState)
        }
    }

    private fun render(viewState: SplashScreenViewState.Idle){

    }

    private fun render(viewState: SplashScreenViewState.ToScreen){
        snackbar.showSnackBar(viewState.message, Snackbar.LENGTH_LONG)
        tb.appBar.setBackgroundColor(resources?.getColor(R.color.colorAccentSecondary)?:R.color.colorAccent)
//        snacky.showSnackBar("lul")
    }


    @Inject
    lateinit var _p : SplashScreenPresenter

    override fun createPresenter(): SplashScreenPresenter = _p

    override fun getLayoutId(): Int = R.layout.splash_screen


}