
import android.content.Context
import com.biganto.visual.roompark.base.ICollapsingToolBar
import com.biganto.visual.roompark.base.RoomParkMainActivity
import com.biganto.visual.roompark.di.dagger.AppComponent
import com.biganto.visual.roompark.di.dagger.AuthContractModule
import com.biganto.visual.roompark.di.dagger.PerScreen
import com.biganto.visual.roompark.domain.contract.AuthContract
import com.biganto.visual.roompark.presentation.screen.splash.SplashScreenController
import com.biganto.visual.roompark.presentation.screen.splash.SplashScreenPresenter
import dagger.Binds
import dagger.BindsInstance
import dagger.Component
import dagger.Module

//package com.biganto.visual.roompark.presentation.screen.splash
//
//import com.biganto.visual.roompark.di.dagger.AppComponent
//import com.biganto.visual.roompark.di.dagger.PerScreen
//import dagger.Component
//import dagger.Provides
//
///**
// * Created by Vladislav Bogdashkin on 30.09.2019.
// */
//
//@PerScreen
//@Component(dependencies = [AppComponent::class])
//interface SplashComponent {
//    @Provides
//    fun presenter(): SplashScreenPresenter
//}
//


//
@PerScreen
@Component(
    modules = [SplashScreenModule::class],
    dependencies = [AppComponent::class])
interface SplashScreenComponent {

    @Component.Factory
    interface Factory{
        fun create(
            appComponent: AppComponent
            ,@BindsInstance activity: RoomParkMainActivity
        ):SplashScreenComponent
    }

    val presenter: SplashScreenPresenter

    fun inject(controller: SplashScreenController)
}

@Module
abstract class SplashScreenModule{

    @PerScreen
    @Binds
   abstract fun provideContext(activity: RoomParkMainActivity): Context


    @PerScreen
    @Binds
    abstract fun provideAuth(contract: AuthContractModule): AuthContract


//    @Binds
//    abstract fun provideContext(activity: Activity): Context


//    @Binds
//    abstract fun provideSnack(snack:ISnackBarProvider) : ISnackBarProvider

    @PerScreen
    @Binds
    abstract fun provideToolbar(activitiy: RoomParkMainActivity): ICollapsingToolBar
}
